;;;
;;;
;;;          LISP-Routine erstellt ein Rechteck um einen Bemaungstext
;;;
;;;                            Autor Stephan Vette
;;;
;;;

(defun *error* (msg)
  (setq *error* olderr)
  (princ (strcat "\nFehler bei TBRD: " msg))
  (altsv)
  (princ)
)

(defun altsv ()
  (setvar "CMDECHO" cmde)
  (setvar "FILLETRAD" frad)
  (setvar "APERTURE" apert)
  (setq *error* olderr)
  (princ)
)

(defun C:TBRD ()
  (setq olderr *error*)
  (setq grechner "D:/Programme/ACAD2000/GEOMCAL.ARX")
  (arxload grechner T)
  (setq cmde (getvar "CMDECHO"))
  (setq bmde (getvar "BLIPMODE"))
  (setq frad (getvar "FILLETRAD"))
  (setq apert (getvar "APERTURE"))
  (setvar "CMDECHO" 0)
  (setvar "APERTURE" 1)
  (setq gren (nentsel "\nText auswhlen: "))
  (while gren
    (setq txtel (entget (car gren)))
    (command "_UCS" "_E" (car gren))
    (setq habst nil)
    (setq tewi 0.0)
    (if	abst
      (progn
	(setq habst
	       (getreal
		 (strcat "\nAbstand eingeben <" (rtos abst 2 2) ">: ")
	       )
	)
	(if habst
	  (setq abst habst)
	  (setq abst abst)
	)
      )
      (setq abst (getreal "\nAbstand eingeben: "))
    )
    (initget "Ja Nein")
    (setq rdwert (getkword "\nEcken ausrunden? Ja/<Nein>: "))
    (setq tb (textbox (cdr txtel)))
    (setq p1 (car tb))
    (setq p2 (cadr tb))
    (cal "bpt=plt(p1,p2,0.5)")
    (setq l (/ (distance p1 p2) 2))
    (setq tbw (angle p1 p2))
    (setq gw (+ tbw tewi))
    (setq hw (+ tewi (/ pi 4)))
    (setq hp1 (polar bpt gw l))
    (setq pt1 (polar hp1 hw (/ abst (cos (/ pi 4)))))
    (setq inv_tewi (+ tewi pi))
    (setq rec_tewi (+ tewi (/ pi 2)))
    (setq rec_inv_tewi (+ inv_tewi (/ pi 2)))
    (setq pt2 (polar pt1
		     inv_tewi
		     (+ (* (distance p1 p2) (cos tbw)) (* abst 2))
	      )
    )
    (setq pt3 (polar pt2
		     rec_inv_tewi
		     (+ (* (distance p1 p2) (sin tbw)) (* abst 2))
	      )
    )
    (setq pt4 (polar pt3
		     tewi
		     (+ (* (distance p1 p2) (cos tbw)) (* abst 2))
	      )
    )
    (command "_pline" pt1 pt2 pt3 pt4 "_c")
    (if	(wcmatch rdwert "J,Ja")
      (progn
	(setvar "filletrad" abst)
	(cal "ppt1=plt(pt1,pt2,0.5)")
	(cal "ppt2=plt(pt2,pt3,0.5)")
	(cal "ppt3=plt(pt3,pt4,0.5)")
	(cal "ppt4=plt(pt4,pt1,0.5)")
	(command "_fillet" ppt1 ppt2)
	(command "_fillet" ppt2 ppt3)
	(command "_fillet" ppt3 ppt4)
	(command "_fillet" ppt1 ppt4)
      )
    )
    (setq gren nil)
    (setq gren (nentsel "\nText auswhlen: "))
  )
  (altsv)
  (princ)
)
(prompt "\nProgramm TXTBOXRD.LSP geladen !")
(prompt "\nBitte mit C:TBRD aufrufen !")
(prompt "\n")
(princ)
